diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/arch/arm/include/asm/arch-socfpga_arria10/hardware.h u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/arch/arm/include/asm/arch-socfpga_arria10/hardware.h
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/arch/arm/include/asm/arch-socfpga_arria10/hardware.h	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/arch/arm/include/asm/arch-socfpga_arria10/hardware.h	2020-02-07 13:29:45.840627000 +0100
***************
*** 58,63 ****
--- 58,64 ----
  #define SOCFPGA_MPUL2_ADDRESS			(0xfffff000)
  #define SOCFPGA_I2C0_ADDRESS			(0xffc02200)
  #define SOCFPGA_I2C1_ADDRESS			(0xffc02300)
+ #define SOCFPGA_I2C4_ADDRESS			(0xffc02600)
  #endif /***************** TEST_AT_ASIMOV *****************/
  
  #define SOCFPGA_ECC_OCRAM_ADDRESS		(0xff8c3000)
diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/board/altera/socfpga_arria10/socfpga_arria10.c u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/board/altera/socfpga_arria10/socfpga_arria10.c
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/board/altera/socfpga_arria10/socfpga_arria10.c	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/board/altera/socfpga_arria10/socfpga_arria10.c	2020-02-07 13:29:45.840627000 +0100
***************
*** 16,22 ****
  int checkboard(void)
  {
  	WATCHDOG_RESET();
! 	puts("BOARD : Altera SOCFPGA Arria 10 Dev Kit\n");
  	return 0;
  }
- 
--- 16,22 ----
  int checkboard(void)
  {
  	WATCHDOG_RESET();
! 	//puts("BOARD : Altera SOCFPGA Arria 10 Dev Kit\n");
! 	puts("BOARD : MatrixVision BCXT 10GigE Camera\n");
  	return 0;
  }
diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/common/board_f.c u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/common/board_f.c
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/common/board_f.c	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/common/board_f.c	2020-02-07 13:29:45.840627000 +0100
***************
*** 811,816 ****
--- 811,866 ----
  	return 0;
  }
  
+ static int mvCheckMax10Config(void)
+ {
+ 	unsigned int* SYSMGR_INITSWLASTID_ADDR = (unsigned int*)0xffd06210;
+ 	unsigned int* SYSMGR_INITSWSTATE_ADDR = (unsigned int*)0xffd0620c;
+ 	unsigned int* RSTMGR_CTRL_ADDR = (unsigned int*)0xffd0500c;
+ 	unsigned int MAX10_I2C_ADDR = 0x55;
+ 	unsigned int MAX10_SYSID_BASE_ADDR = 0x00;
+ 
+ 	//check if we are booting from UBoot image 0
+ 	unsigned int value = *SYSMGR_INITSWLASTID_ADDR;	
+ 	puts("UBoot started from image: ");
+ 	puts((value == 0) ? "0\r\n" : (value == 1) ? "1\r\n" : (value == 2) ? "2\r\n" : "3\r\n");
+ 	if (value == 0)
+ 	{
+ 		int success = i2c_probe(MAX10_I2C_ADDR);
+ 		if (success != 0)
+ 		{
+ 			puts("mvCheckMax10Config: I2C probe for MAX10 failed. Continue with normal boot sequence...\r\n");
+ 			return 0;
+ 		}
+ 		uint8_t max10SysId = i2c_reg_read(MAX10_I2C_ADDR, MAX10_SYSID_BASE_ADDR);
+               //bits [3..0] tell us which Max10 FPGA has been loaded
+ 		if ((max10SysId & 0xf) == 0)
+ 		{
+ 			//Max10 started with rescue FPGA ==> next time boot from image 2
+ 			value &= ~(0x3);
+ 			value |= 0x2;
+ 		}
+ 		else
+ 		{
+ 			//Max10 started with user FPGA ==> next time boot from image 1
+ 			value &= ~(0x3);
+ 			value |= 0x1;
+ 		}
+ 		*SYSMGR_INITSWLASTID_ADDR = value;
+ 		puts("mvCheckMax10Config: write magic number into sw state register...\r\n");
+ 		//write magic number into swstate register
+ 		*SYSMGR_INITSWSTATE_ADDR = 0x49535756;
+ 		puts("mvCheckMax10Config: initiating warm reset...\r\n");
+ 		*RSTMGR_CTRL_ADDR |= 0x2;
+ 		while(true);
+ 	}
+ 	else
+ 	{
+ 		puts("mvCheckMax10Config: Arria10 was not started from UBoot image 0. Continue with normal boot sequence...\r\n");
+ 	}
+ 	
+ 	return 0;
+ }
+ 
  static init_fnc_t init_sequence_f[] = {
  #ifdef CONFIG_SANDBOX
  	setup_ram_buf,
***************
*** 909,914 ****
--- 959,967 ----
  #if defined(CONFIG_HARD_SPI)
  	init_func_spi,
  #endif
+ 	mvCheckMax10Config,
+ 	
+ 	
  #ifdef CONFIG_X86
  	dram_init_f,		/* configure available RAM banks */
  	calculate_relocation_address,
diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/drivers/i2c/designware_i2c.c u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/drivers/i2c/designware_i2c.c
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/drivers/i2c/designware_i2c.c	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/drivers/i2c/designware_i2c.c	2020-02-07 13:40:07.228605000 +0100
***************
*** 14,19 ****
--- 14,22 ----
  static unsigned int current_bus = 0;
  #endif
  
+ #define I2C_MM_WRITE_RETRY_COUNT 10000
+ #define I2C_MM_READ_RETRY_COUNT 100
+ 
  static struct i2c_regs *i2c_regs_p =
      (struct i2c_regs *)CONFIG_SYS_I2C_BASE;
  
***************
*** 109,114 ****
--- 112,122 ----
  	return 0;
  }
  
+ void i2c_int_clear(void)
+ {
+ 	readl(&i2c_regs_p->ic_clr_intr);
+ }
+ 
  /*
   * i2c_init - Init function
   * @speed:	required i2c speed
***************
*** 125,135 ****
--- 133,151 ----
  	enbl &= ~IC_ENABLE_0B;
  	writel(enbl, &i2c_regs_p->ic_enable);
  
+ 	//write SDA TX hold time (this must be done before the i2C controller is configuread as master for some reason)
+ 	unsigned short sda_tx_hold = readl(&i2c_regs_p->ic_sda_hold);
+ 	unsigned int scl_lowtime = (speed >= I2C_FAST_SPEED) ? MIN_FS_SCL_LOWTIME : MIN_SS_SCL_LOWTIME;
+ 	sda_tx_hold |= (IC_CLK * scl_lowtime) / NANO_TO_MICRO / 2;  //SDA will be changed in the middle of the SCL low period
+ 	writel(sda_tx_hold, &i2c_regs_p->ic_sda_hold);
+ 	sda_tx_hold = readl(&i2c_regs_p->ic_sda_hold);    
+ 
  	writel((IC_CON_SD | IC_CON_SPD_FS | IC_CON_MM), &i2c_regs_p->ic_con);
  	writel(IC_RX_TL, &i2c_regs_p->ic_rx_tl);
  	writel(IC_TX_TL, &i2c_regs_p->ic_tx_tl);
  	i2c_set_bus_speed(speed);
  	writel(IC_STOP_DET, &i2c_regs_p->ic_intr_mask);
+ 	writel(IC_TX_ABRT, &i2c_regs_p->ic_intr_mask);
  	writel(slaveadd, &i2c_regs_p->ic_sar);
  
  	/* Enable i2c */
***************
*** 137,142 ****
--- 153,160 ----
  	enbl |= IC_ENABLE_0B;
  	writel(enbl, &i2c_regs_p->ic_enable);
  
+ 	i2c_int_clear();
+ 
  #ifdef CONFIG_I2C_MULTI_BUS
  	bus_initialized[current_bus] = 1;
  #endif
***************
*** 198,203 ****
--- 216,222 ----
  
  static int i2c_xfer_init(uchar chip, uint addr, int alen)
  {
+ 	i2c_int_clear();
  	if (i2c_wait_for_bb())
  		return 1;
  
***************
*** 230,236 ****
--- 249,269 ----
  	}
  
  	i2c_flush_rxfifo();
+ 	i2c_int_clear();
+ 	return 0;
+ }
  
+ int i2c_check_ARBLOST_or_NACK(void)
+ {
+ 	unsigned int abortSource = 0;
+ 	if ((readl(&i2c_regs_p->ic_raw_intr_stat) & IC_TX_ABRT) != 0) {
+ 		abortSource = readl(&i2c_regs_p->ic_tx_abrt_source);
+ 		unsigned int mask = ABRT_7B_ADDR_NOACK | ABRT_10ADDR1_NOACK | ABRT_10ADDR2_NOACK | ABRT_TXDATA_NOACK | ARB_LOST;
+ 		if ((abortSource & mask) != 0)
+ 		{
+ 			return 1;
+ 		}
+ 	}
  	return 0;
  }
  
***************
*** 247,252 ****
--- 280,289 ----
  int i2c_read(uchar chip, uint addr, int alen, uchar *buffer, int len)
  {
  	unsigned long start_time_rx;
+ 	int result = 0;
+ 	int retry = I2C_MM_READ_RETRY_COUNT;
+ 	int length;
+ 	uchar* data;
  
  #ifdef CONFIG_SYS_I2C_EEPROM_ADDR_OVERFLOW
  	/*
***************
*** 266,293 ****
  	debug("%s: fix addr_overflow: chip %02x addr %02x\n", __func__, chip,
  	      addr);
  #endif
  
! 	if (i2c_xfer_init(chip, addr, alen))
! 		return 1;
! 
! 	start_time_rx = get_timer(0);
! 	while (len) {
! 		if (len == 1)
! 			writel(IC_CMD | IC_STOP, &i2c_regs_p->ic_cmd_data);
! 		else
! 			writel(IC_CMD, &i2c_regs_p->ic_cmd_data);
! 
! 		if (readl(&i2c_regs_p->ic_status) & IC_STATUS_RFNE) {
! 			*buffer++ = (uchar)readl(&i2c_regs_p->ic_cmd_data);
! 			len--;
! 			start_time_rx = get_timer(0);
! 
! 		} else if (get_timer(start_time_rx) > I2C_BYTE_TO) {
! 				return 1;
  		}
  	}
! 
! 	return i2c_xfer_finish();
  }
  
  /*
--- 303,342 ----
  	debug("%s: fix addr_overflow: chip %02x addr %02x\n", __func__, chip,
  	      addr);
  #endif
+ 	while(retry--)
+ 	{
+ 		result = i2c_xfer_init(chip, addr, alen);
+ 		if (result != 0) continue;
+ 		length = len;
+ 		data = buffer;
+ 		start_time_rx = get_timer(0);
+ 		while (length) {
+ 			if (length == 1)
+ 				writel(IC_CMD | IC_STOP, &i2c_regs_p->ic_cmd_data);
+ 			else
+ 				writel(IC_CMD, &i2c_regs_p->ic_cmd_data);
  
! 			if (i2c_check_ARBLOST_or_NACK() != 0) {
! 				result = 1;
! 				break;
! 			}
! 			
! 			if (readl(&i2c_regs_p->ic_status) & IC_STATUS_RFNE) {
! 				*data++ = (uchar)readl(&i2c_regs_p->ic_cmd_data);
! 				length--;
! 				start_time_rx = get_timer(0);
! 
! 			} else if (get_timer(start_time_rx) > I2C_BYTE_TO) {
! 					result = 1;
! 					break;
! 			}
  		}
+ 		if (result != 0) continue;
+ 		result = i2c_xfer_finish();
+ 		if (result != 0) continue;
+ 		else break;
  	}
! 	return result;
  }
  
  /*
***************
*** 304,309 ****
--- 353,362 ----
  {
  	int nb = len;
  	unsigned long start_time_tx;
+ 	int result = 0;
+ 	int retry = I2C_MM_WRITE_RETRY_COUNT;
+ 	int length;
+ 	uchar* data;
  
  #ifdef CONFIG_SYS_I2C_EEPROM_ADDR_OVERFLOW
  	/*
***************
*** 324,349 ****
  	      addr);
  #endif
  
! 	if (i2c_xfer_init(chip, addr, alen))
! 		return 1;
! 
! 	start_time_tx = get_timer(0);
! 	while (len) {
! 		if (readl(&i2c_regs_p->ic_status) & IC_STATUS_TFNF) {
! 			if (--len == 0)
! 				writel(*buffer | IC_STOP, &i2c_regs_p->ic_cmd_data);
! 			else
! 				writel(*buffer, &i2c_regs_p->ic_cmd_data);
! 			buffer++;
! 			start_time_tx = get_timer(0);
! 
! 		} else if (get_timer(start_time_tx) > (nb * I2C_BYTE_TO)) {
! 				printf("Timed out. i2c write Failed\n");
! 				return 1;
  		}
  	}
! 
! 	return i2c_xfer_finish();
  }
  
  /*
--- 377,416 ----
  	      addr);
  #endif
  
! 	while(retry--)
! 	{	
! 		result = i2c_xfer_init(chip, addr, alen);
! 		if (result != 0) continue;
! 		length = len;
! 		data = buffer;
! 		start_time_tx = get_timer(0);
! 		while (length) {
! 			if (readl(&i2c_regs_p->ic_status) & IC_STATUS_TFNF) {
! 				if (--length == 0)
! 					writel(*data | IC_STOP, &i2c_regs_p->ic_cmd_data);
! 				else
! 					writel(*data, &i2c_regs_p->ic_cmd_data);
! 
! 				if (i2c_check_ARBLOST_or_NACK() != 0) {
! 					result = 1;
! 					break;
! 				}
! 				
! 				data++;
! 				start_time_tx = get_timer(0);
! 
! 			} else if (get_timer(start_time_tx) > (nb * I2C_BYTE_TO)) {
! 					printf("Timed out. i2c write Failed\n");
! 					result = 1;
! 					break;
! 			}
  		}
+ 		if (result != 0) continue;
+ 		result = i2c_xfer_finish();
+ 		if (result != 0) continue;
+ 		else break;
  	}
! 	return result;
  }
  
  /*
***************
*** 359,365 ****
--- 426,435 ----
  	 */
  	ret = i2c_read(chip, 0, 1, (uchar *)&tmp, 1);
  	if (ret)
+ 	{
+ 		i2c_xfer_finish();
  		i2c_init(CONFIG_SYS_I2C_SPEED, CONFIG_SYS_I2C_SLAVE);
+ 	}
  
  	return ret;
  }
diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/drivers/i2c/designware_i2c.h u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/drivers/i2c/designware_i2c.h
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/drivers/i2c/designware_i2c.h	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/drivers/i2c/designware_i2c.h	2020-02-07 13:35:05.640616000 +0100
***************
*** 40,46 ****
  	u32 ic_status;
  	u32 ic_txflr;
  	u32 ix_rxflr;
! 	u32 reserved_1;
  	u32 ic_tx_abrt_source;
  };
  
--- 40,46 ----
  	u32 ic_status;
  	u32 ic_txflr;
  	u32 ix_rxflr;
! 	u32 ic_sda_hold;
  	u32 ic_tx_abrt_source;
  };
  
***************
*** 130,133 ****
--- 130,140 ----
  #define I2C_FAST_SPEED		400000
  #define I2C_STANDARD_SPEED	100000
  
+ /* i2c tx abort source register definitions*/
+ #define ABRT_7B_ADDR_NOACK (1 << 0)
+ #define ABRT_10ADDR1_NOACK (1 << 1)
+ #define ABRT_10ADDR2_NOACK (1 << 2)
+ #define ABRT_TXDATA_NOACK  (1 << 3)
+ #define ARB_LOST           (1 << 12)
+ 
  #endif /* __DW_I2C_H_ */
diff -crB u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/include/configs/socfpga_arria10.h u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/include/configs/socfpga_arria10.h
*** u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr_original/include/configs/socfpga_arria10.h	2017-09-20 06:23:35.000000000 +0200
--- u-boot-socfpga-rel_socfpga_v2014.10_arria10_bringup_18.02.01_pr/include/configs/socfpga_arria10.h	2020-02-07 13:29:45.840627000 +0100
***************
*** 258,345 ****
  #error "MAX_DTB_SIZE_IN_RAM is too big. It will overwrite zImage in memory."
  #endif
  
! #define CONFIG_EXTRA_ENV_SETTINGS \
! 	"verify=y\0" \
! 	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
! 	"fdtaddr=" __stringify(CONFIG_SYS_DTB_ADDR) "\0" \
! 	"bootimage=zImage\0" \
! 	"bootimagesize=0x5F0000\0" \
! 	"fdtimage=" __stringify(CONFIG_LINUX_DTB_NAME) "\0" \
! 	"fdtimagesize=" __stringify(MAX_DTB_SIZE_IN_RAM) "\0" \
! 	"fdt_high=0x2000000\0" \
! 	"mmcloadcmd=fatload\0" \
! 	"mmcloadpart=1\0" \
! 	"mmcroot=/dev/mmcblk0p2\0" \
! 	"qspi_upage_cs=2\0" \
! 	"qspiloadcs=0\0" \
! 	"qspibootimageaddr=0x120000\0" \
! 	"qspifdtaddr=0x100000\0" \
! 	"qspirbfaddr=" __stringify(CONFIG_QSPI_RBF_ADDR) "\0" \
! 	"qspiroot=/dev/mtdblock1\0" \
! 	"qspirootfstype=jffs2\0" \
! 	"nandbootimageaddr=0x120000\0" \
! 	"nandfdtaddr=0x100000\0" \
! 	"nandrbfcoreimage=0x820000\0" \
! 	"nandroot=/dev/mtdblock1\0" \
! 	"nandrootfstype=jffs2\0" \
! 	"nandrbfcore_rbf_prog=" \
! 		"fpga loadfs 0 nand 0:0 ${nandrbfcoreimage} core\0" \
! 	"ramboot=setenv bootargs " CONFIG_BOOTARGS \
! 		" printk.time=1 debug mem=${fdt_high} " \
! 		"lpj=3977216;fpgabr 1; bootz ${loadaddr} - ${fdtaddr}\0" \
! 	"mmcload=mmc rescan;" \
! 		"${mmcloadcmd} mmc 0:${mmcloadpart} ${loadaddr} ${bootimage};" \
! 		"${mmcloadcmd} mmc 0:${mmcloadpart} ${fdtaddr} ${fdtimage}\0" \
! 	"mmcboot=setenv bootargs " CONFIG_BOOTARGS \
! 		" root=${mmcroot} rw rootwait;" \
! 		"fpgabr 1;" \
! 		"bootz ${loadaddr} - ${fdtaddr}\0" \
! 	"netboot=dhcp ${bootimage};" \
! 		"tftp ${fdtaddr} ${fdtimage} ; run ramboot\0" \
! 	"qspiload=sf probe ${qspiloadcs};" \
! 		"sf read ${loadaddr} ${qspibootimageaddr} ${bootimagesize};" \
! 		"sf read ${fdtaddr} ${qspifdtaddr} ${fdtimagesize};\0" \
! 	"qspiboot=setenv bootargs " CONFIG_BOOTARGS \
! 		" root=${qspiroot} rw rootfstype=${qspirootfstype};" \
! 		"fpgabr 1;" \
! 		"bootz ${loadaddr} - ${fdtaddr}\0" \
! 	"nandload=" \
! 		"nand read ${loadaddr} ${nandbootimageaddr} ${bootimagesize};" \
! 		"nand read ${fdtaddr} ${nandfdtaddr} ${fdtimagesize}\0" \
! 	"nandboot=setenv bootargs " CONFIG_BOOTARGS \
! 		" root=${nandroot} rw rootfstype=${nandrootfstype};" \
! 		"fpgabr 1;" \
! 		"bootz ${loadaddr} - ${fdtaddr}\0" \
! 	"bootcmd=" CONFIG_BOOTCOMMAND "\0" \
! 	"u-boot_swstate_reg=0xffd0620c\0" \
! 	"u-boot_image_valid=0x49535756\0" \
! 	"set_initswstate=" \
! 		"mw ${u-boot_swstate_reg} ${u-boot_image_valid}\0" \
! 	"ksz9031-rgmii-ctrl-skew=0x70\0" \
! 	"ksz9031-rgmii-rxd-skew=0x7777\0" \
! 	"ksz9031-rgmii-txd-skew=0x0\0" \
! 	"ksz9031-rgmii-clock-skew=0x3fc\0" \
! 	"fpga=0\0" \
! 	"fpgadata=0x2000000\0" \
! 	"fpgadatasize=0x700000\0" \
! 	"rbftosdramaddr=0x40\0" \
! 	"rbfcoreimage=" RBFCOREIMAGE \
! 	"cff_devsel_partition=0:1\0" \
! 	"qspirbfcoreimage=0x820000\0" \
! 	"qspirbfcore_rbf_prog=" \
! 		"fpga loadfs 0 qspi 0:0 ${qspirbfcoreimage} core\0" \
! 	"core_rbf_prog=fpga loadfs 0 mmc 0:1 ${rbfcoreimage} core\0" \
! 	CONFIG_KSZ9021_CLK_SKEW_ENV "=" \
! 		__stringify(CONFIG_KSZ9021_CLK_SKEW_VAL) "\0" \
! 	CONFIG_KSZ9021_DATA_SKEW_ENV "=" \
! 		__stringify(CONFIG_KSZ9021_DATA_SKEW_VAL) "\0" \
! 	"scriptfile=u-boot.scr\0" \
! 	"callscript=if fatload mmc 0:1 $fpgadata $scriptfile;" \
! 			"then source $fpgadata;" \
! 		"else" \
! 			"echo Optional boot script not found." \
! 			"Continuing to boot normally;" \
! 		"fi;\0"
  
  /*
   * Environment setup
--- 258,266 ----
  #error "MAX_DTB_SIZE_IN_RAM is too big. It will overwrite zImage in memory."
  #endif
  
! /* =================================================== */
! #include "Arria10UBootEnvironment.h"
! /* =================================================== */
  
  /*
   * Environment setup
***************
*** 495,501 ****
  /*
   * network support
   */
! #define CONFIG_DESIGNWARE_ETH
  #ifdef CONFIG_DESIGNWARE_ETH
  #define CONFIG_TX_DESCR_NUM		2
  #define CONFIG_RX_DESCR_NUM		2
--- 416,424 ----
  /*
   * network support
   */
! /*
!  * #define CONFIG_DESIGNWARE_ETH
!  */
  #ifdef CONFIG_DESIGNWARE_ETH
  #define CONFIG_TX_DESCR_NUM		2
  #define CONFIG_RX_DESCR_NUM		2
***************
*** 700,706 ****
  #ifdef CONFIG_I2C
  #define CONFIG_HARD_I2C
  #define CONFIG_DW_I2C
! #define CONFIG_SYS_I2C_BASE             SOCFPGA_I2C1_ADDRESS
  #define CONFIG_SYS_EEPROM_PAGE_WRITE_DELAY_MS	5
  /* using standard mode which the speed up to 100Kb/s) */
  #define CONFIG_SYS_I2C_SPEED            (100000)
--- 623,629 ----
  #ifdef CONFIG_I2C
  #define CONFIG_HARD_I2C
  #define CONFIG_DW_I2C
! #define CONFIG_SYS_I2C_BASE             SOCFPGA_I2C4_ADDRESS
  #define CONFIG_SYS_EEPROM_PAGE_WRITE_DELAY_MS	5
  /* using standard mode which the speed up to 100Kb/s) */
  #define CONFIG_SYS_I2C_SPEED            (100000)

